"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPropsWithInnerUiSchema = void 0;
const React = require("react");
const utils_1 = require("../utils");
const BaseComponent_1 = require("./BaseComponent");
const Context_1 = require("../Context");
function getPropsWithInnerUiSchema(props) {
    return Object.assign(Object.assign({}, props), { uiSchema: utils_1.getInnerUiSchema(props.uiSchema) });
}
exports.getPropsWithInnerUiSchema = getPropsWithInnerUiSchema;
/**
 * Virtual SchemaFields are components which are just state transforming machines.
 */
function VirtualSchemaField(ComposedComponent) {
    let VirtualSchemaField = class VirtualSchemaField extends ComposedComponent {
        constructor(...args) {
            super(...args);
            this.getStateFromProps = (props) => {
                const propsWithInnerUiSchema = getPropsWithInnerUiSchema(props);
                const state = super.getStateFromProps ? super.getStateFromProps(propsWithInnerUiSchema, props) : propsWithInnerUiSchema;
                return Object.assign(Object.assign({}, propsWithInnerUiSchema), state);
            };
            this.render = () => {
                if (super.render)
                    return super.render();
                const SchemaField = this.props.registry.fields.SchemaField;
                const filterProps = (props) => [
                    "schema",
                    "uiSchema",
                    "idSchema",
                    "formData",
                    "errorSchema",
                    "registry",
                    "onChange",
                    "disabled",
                    "readonly"
                ].reduce((_props, prop) => {
                    if (prop in props)
                        _props[prop] = props[prop];
                    return _props;
                }, {});
                return (React.createElement(SchemaField, Object.assign({}, filterProps(Object.assign(Object.assign({}, this.props), this.state)))));
            };
            this.getStateFromProps = this.getStateFromProps.bind(this);
            this.render = this.render.bind(this);
        }
        getUiOptions() {
            return utils_1.getUiOptions(this.props.uiSchema);
        }
    };
    VirtualSchemaField.displayName = utils_1.getReactComponentName(ComposedComponent);
    VirtualSchemaField = __decorate([
        BaseComponent_1.default
    ], VirtualSchemaField);
    if (ComposedComponent.getName) {
        const name = ComposedComponent.getName();
        Context_1.default("VIRTUAL_SCHEMA_NAMES")[name] = true;
        if (process.env.NODE_ENV !== "production" && ComposedComponent.getName() !== utils_1.getReactComponentName(ComposedComponent)) {
            console.warn(`${utils_1.getReactComponentName(ComposedComponent)} getName() doesn't return it's component name! (It returned '${name}')`);
        }
    }
    else {
        console.warn(`${utils_1.getReactComponentName(ComposedComponent)} is missing static getName() method!`);
    }
    return VirtualSchemaField;
}
exports.default = VirtualSchemaField;
