"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const components_1 = require("../components");
const BaseComponent_1 = require("../BaseComponent");
const utils_2 = require("@rjsf/utils");
let ArrayBulkField = class ArrayBulkField extends React.Component {
    constructor(props) {
        super(props);
        this.getStateFromProps = (props) => {
            let state = {};
            const { rowAddAmount } = utils_1.getUiOptions(props.uiSchema);
            state.rowAddAmount = 10;
            if (rowAddAmount > 0)
                state.rowAddAmount = rowAddAmount;
            if (props.formData && props.formData.length > this.state.rowAmount) {
                state.rowAmount = props.formData.length + state.rowAddAmount - (props.formData.length % state.rowAddAmount);
            }
            return state;
        };
        this.renderItems = () => {
            let rows = [];
            let idx = 0;
            let data = this.props.formData || [];
            while (data.length < this.state.rowAmount) {
                data.push({});
            }
            const SchemaField = this.props.registry.fields.SchemaField;
            if (data)
                data.forEach((item) => {
                    rows.push(React.createElement(SchemaField, { key: idx, formData: item, onChange: this.onChangeForIdx(idx), schema: this.props.schema.items, uiSchema: this.props.uiSchema.items, idSchema: { $id: this.props.idSchema.$id + "_" + idx }, registry: this.props.registry, errorSchema: this.props.errorSchema[idx] }));
                    idx++;
                });
            return rows;
        };
        this.onChangeForIdx = (idx) => {
            return (itemFormData) => {
                let formData = this.props.formData;
                if (!formData)
                    formData = [];
                formData[idx] = itemFormData;
                this.props.onChange(formData.filter(item => { return Object.keys(item).length; }));
            };
        };
        this.onAddClick = (event) => {
            event.preventDefault();
            this.setState({ rowAmount: this.state.rowAmount + this.state.rowAddAmount });
        };
        this.state = Object.assign({ rowAmount: 0 }, this.getStateFromProps(props));
    }
    render() {
        const TitleFieldTemplate = utils_2.getTemplate("TitleFieldTemplate", this.props.registry, utils_1.getUiOptions(this.props.uiSchema));
        return (React.createElement("fieldset", null,
            React.createElement(TitleFieldTemplate, { title: this.props.schema.title || this.props.name, schema: this.props.schema, uiSchema: this.props.uiSchema, registry: this.props.registry }),
            this.renderItems(),
            React.createElement(components_1.Button, { onClick: this.onAddClick }, "Lis\u00E4\u00E4 havaintorivej\u00E4"),
            React.createElement("br", null)));
    }
};
ArrayBulkField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            rowAddAmount: PropTypes.number
        })
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.array.isRequired
};
ArrayBulkField = __decorate([
    BaseComponent_1.default
], ArrayBulkField);
exports.default = ArrayBulkField;
