"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInjectedUiSchema = void 0;
const React = require("react");
const PropTypes = require("prop-types");
const immutability_helper_1 = require("immutability-helper");
const utils_1 = require("../../utils");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
let ContextInjectionField = class ContextInjectionField extends React.Component {
    static getName() { return "ContextInjectionField"; }
    getStateFromProps(props) {
        const { injections, target = "uiSchema" } = this.getUiOptions();
        const container = props[target];
        return { [target]: getInjectedUiSchema(container, injections, props.formContext.uiSchemaContext) };
    }
};
ContextInjectionField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            injections: PropTypes.object.isRequired,
            target: PropTypes.oneOf(["uiSchema", "schema"]),
        }).isRequired,
        uiSchema: PropTypes.object
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string, PropTypes.number, PropTypes.bool]),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array", "object", "string", "integer", "number", "boolean"])
    }).isRequired,
};
ContextInjectionField = __decorate([
    VirtualSchemaField_1.default
], ContextInjectionField);
exports.default = ContextInjectionField;
function getInjectedUiSchema(uiSchema, injections, uiSchemaContext) {
    let injected = false;
    const updateObject = {};
    for (let injectionPath in injections) {
        const splitted = injectionPath.substring(1).split("/");
        const last = splitted.pop();
        const tail = splitted.reduce((pointer, path) => {
            if (!pointer[path])
                pointer[path] = {};
            return pointer[path];
        }, updateObject);
        let value = injections[injectionPath];
        if (value.match(/%{.*}/)) {
            while (value.match(/%{.*}/)) {
                const [match, innerValue] = value.match(/%{(.*)}/);
                value = value.replace(match, utils_1.parseJSONPointer(uiSchemaContext, innerValue));
            }
        }
        else {
            value = utils_1.parseJSONPointer(uiSchemaContext, value);
        }
        tail[last] = { $set: value };
        injected = true;
    }
    if (injected)
        uiSchema = immutability_helper_1.default(uiSchema, updateObject);
    return uiSchema;
}
exports.getInjectedUiSchema = getInjectedUiSchema;
