/**
 * Sets given default values to target fields.
 * uiSchema = { "ui:options": {
 *  "default": [
 *    {
 *      field1: defaultValue1,
 *      field2: defaultValue2
 *    }
 *    ...
 *  ]
 * }}
 */
export default class DefaultValueArrayField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Validator<PropTypes.InferProps<{
                default: PropTypes.Validator<object>;
            }>>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<any[]>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(): {
        onChange: (formData: any) => void;
    };
    onChange: (formData: any) => void;
}
import * as React from "react";
import * as PropTypes from "prop-types";
