"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
const utils_1 = require("../../utils");
const utils_2 = require("../../utils");
let FakePropertyField = class FakePropertyField extends React.Component {
    static getName() { return "FakePropertyField"; }
    getStateFromProps(props) {
        const { fields } = this.getUiOptions();
        let properties = props.schema.properties;
        let uiSchema = props.uiSchema;
        let formData = props.formData;
        Object.keys(fields).forEach((prop) => {
            const { schema, uiSchema: _uiSchema, formData: _formData, skipIfEmpty = false } = fields[prop];
            if (skipIfEmpty && !utils_2.hasData(_formData) && !utils_2.hasData(formData[prop])) {
                return false;
            }
            properties = utils_1.updateSafelyWithJSONPointer(properties, schema, prop);
            uiSchema = utils_1.updateSafelyWithJSONPointer(uiSchema, _uiSchema, prop);
            formData = _formData
                ? utils_1.updateSafelyWithJSONPointer(formData, _formData, prop)
                : formData;
        });
        return {
            schema: Object.assign(Object.assign({}, props.schema), { properties }),
            uiSchema,
            formData
        };
    }
};
FakePropertyField.propTypes = {
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired,
    formData: PropTypes.object.isRequired
};
FakePropertyField = __decorate([
    VirtualSchemaField_1.default
], FakePropertyField);
exports.default = FakePropertyField;
