"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const GridLayoutField = (props) => {
    let { schema, uiSchema } = props;
    const { SchemaField } = props.registry.fields;
    uiSchema = Object.assign(Object.assign({}, uiSchema), { "ui:grid": uiSchema["ui:options"] });
    delete uiSchema["ui:field"];
    if (utils_1.getUiOptions(uiSchema).label === false) {
        Object.keys(schema.properties).forEach(propertyName => {
            const propertyUiSchema = (uiSchema[propertyName] || {});
            uiSchema[propertyName] = Object.assign(Object.assign({}, propertyUiSchema), { "ui:options": Object.assign(Object.assign({}, (propertyUiSchema["ui:options"] || {})), { label: false }) });
        });
    }
    return React.createElement(SchemaField, Object.assign({}, props, { schema: schema, uiSchema: uiSchema }));
};
GridLayoutField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:grid": PropTypes.shape({
            lg: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            md: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            sm: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            xs: PropTypes.oneOfType([PropTypes.number, PropTypes.object])
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired
};
exports.default = GridLayoutField;
