"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const BaseComponent_1 = require("../BaseComponent");
const utils_1 = require("../../utils");
const immutability_helper_1 = require("immutability-helper");
// TODO should work as widget also
let ImageDisplayField = class ImageDisplayField extends React.Component {
    render() {
        const { SchemaField } = this.props.registry.fields;
        let uiSchema = utils_1.getInnerUiSchema(this.props.uiSchema);
        const { urls = [], buttons = [] } = utils_1.getUiOptions(this.props.uiSchema);
        uiSchema = immutability_helper_1.default(uiSchema, { "ui:options": { buttons: { $set: [...buttons,
                        { position: "left", render: () => React.createElement("div", { className: "laji-form-medias", key: "image-display" }, (Array.isArray(urls) ? urls : [urls]).map(url => React.createElement("div", { className: "media-container", key: url },
                                React.createElement("img", { src: url }))))
                        }
                    ] } } });
        return (React.createElement(React.Fragment, null,
            React.createElement(SchemaField, Object.assign({}, this.props, { uiSchema: uiSchema }))));
    }
};
ImageDisplayField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            urls: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
            buttons: PropTypes.arrayOf(PropTypes.string),
        }),
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array", "object"])
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.array, PropTypes.object])
};
ImageDisplayField = __decorate([
    BaseComponent_1.default
], ImageDisplayField);
exports.default = ImageDisplayField;
