"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
const utils_1 = require("../../utils");
let InputWithDefaultValueButtonField = class InputWithDefaultValueButtonField extends React.Component {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            let { uiSchema, formData } = this.props;
            const uiSchemaContext = this.props.formContext.uiSchemaContext || {};
            const { valueFields } = utils_1.getUiOptions(uiSchema);
            valueFields.forEach(({ field, contextFieldForDefaultValue }) => {
                formData = utils_1.updateSafelyWithJSONPointer(formData, uiSchemaContext[contextFieldForDefaultValue], field);
            });
            this.props.onChange(formData);
        };
    }
    static getName() { return "InputWithDefaultValueButtonField"; }
    getStateFromProps(props) {
        let { schema, uiSchema } = props;
        const { buttonField, buttonLabel } = utils_1.getUiOptions(uiSchema);
        const innerUiSchema = utils_1.getInnerUiSchema(uiSchema);
        const _uiSchemaJSONPointer = utils_1.uiSchemaJSONPointer(schema, buttonField);
        uiSchema = utils_1.updateSafelyWithJSONPointer(innerUiSchema, {
            "ui:widget": "InputWithDefaultValueButtonWidget",
            "ui:options": {
                buttonLabel,
                onClick: this.onClick
            },
        }, _uiSchemaJSONPointer);
        return Object.assign(Object.assign({}, props), { uiSchema });
    }
};
InputWithDefaultValueButtonField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            buttonLabel: PropTypes.string.isRequired,
            buttonField: PropTypes.string.isRequired,
            valueFields: PropTypes.arrayOf(PropTypes.shape({
                field: PropTypes.string.isRequired,
                contextFieldForDefaultValue: PropTypes.string.isRequired
            }).isRequired)
        }).isRequired
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.object]).isRequired
};
InputWithDefaultValueButtonField = __decorate([
    VirtualSchemaField_1.default
], InputWithDefaultValueButtonField);
exports.default = InputWithDefaultValueButtonField;
