"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const BaseComponent_1 = require("../BaseComponent");
const components_1 = require("../components");
const LajiForm_1 = require("../LajiForm");
const MapField_1 = require("./MapField");
const ReactContext_1 = require("../../ReactContext");
let LocalityField = class LocalityField extends React.Component {
    constructor(props) {
        super(props);
        this.showEditor = () => {
            this.setState({ modal: true });
        };
        this.hideEditor = () => {
            this.setState({ modal: false });
        };
        this.setFormRef = (elem) => {
            this.lajiForm = elem;
        };
        this.renderModal = () => {
            const _a = this.props, { onChange } = _a, props = __rest(_a, ["onChange"]); // eslint-disable-line @typescript-eslint/no-unused-vars
            const { Modal } = this.context.theme;
            return (React.createElement(Modal, { dialogClassName: "laji-form image-modal", show: true, onHide: this.hideEditor },
                React.createElement(Modal.Header, { closeButton: true }),
                React.createElement(Modal.Body, null,
                    React.createElement(LajiForm_1.default, Object.assign({ ref: this.setFormRef }, props, { uiSchema: utils_1.getInnerUiSchema(this.props.uiSchema), onSubmit: this.onSubmit, lang: this.props.formContext.lang, showShortcutButton: false, renderSubmit: false, validators: {}, warnings: {}, apiClient: this.props.formContext.apiClient.apiClient, uiSchemaContext: this.props.formContext.uiSchemaContext })),
                    React.createElement(components_1.Button, { block: true, onClick: this.onSubmitClick }, "OK"),
                    React.createElement(components_1.Button, { block: true, onClick: this.hideEditor }, this.props.formContext.translations.Cancel))));
        };
        this.onSubmitClick = (e) => {
            this.lajiForm._onDefaultSubmit(e);
        };
        this.onSubmit = ({ formData }) => {
            this.props.onChange(formData);
            this.hideEditor();
        };
        this.state = {};
    }
    render() {
        const { radius: _radius, geometry } = utils_1.getUiOptions(this.props.uiSchema);
        const fields = Object.keys(this.props.schema.properties);
        const values = fields.filter(s => !utils_1.isEmptyString(this.props.formData[s])).map(f => this.props.formData[f]);
        const radius = typeof _radius === "number"
            ? _radius
            : geometry
                ? MapField_1.getCenterAndRadiusFromGeometry(geometry).radius
                : undefined;
        if (typeof radius === "number") {
            values.push(`(${this.props.formContext.translations.accuracy}: ${parseInt(radius)}m)`);
        }
        const { Panel, Row, Col } = this.context.theme;
        return (React.createElement(Row, null,
            React.createElement(Col, { xs: 12 },
                React.createElement(Panel, { className: utils_1.getUiOptions(this.props.uiSchema).panelClassName },
                    React.createElement(Panel.Body, null,
                        values.map((v, i) => (React.createElement("span", { key: i },
                            v,
                            i < values.length - 1 ? ", " : ""))),
                        React.createElement(components_1.GlyphButton, { onClick: this.showEditor, glyph: "pencil", variant: "default", className: "pull-right" })))),
            this.state.modal && this.renderModal()));
    }
};
LocalityField.contextType = ReactContext_1.default;
LocalityField.propTypes = {
    uiSchema: PropTypes.object,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired,
    formData: PropTypes.object.isRequired
};
LocalityField = __decorate([
    BaseComponent_1.default
], LocalityField);
exports.default = LocalityField;
