"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const BaseComponent_1 = require("../BaseComponent");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const AnyToBooleanField_1 = require("./AnyToBooleanField");
const utils_2 = require("@rjsf/utils");
let MultiAnyToBooleanField = class MultiAnyToBooleanField extends React.Component {
    constructor(props) {
        super(props);
        this.onChange = (index) => (value) => {
            const groupsFormData = this.state.groupsFormData;
            groupsFormData[index] = value;
            this.setState({ groupsFormData: groupsFormData });
            const formData = groupsFormData.reduce((arr, val) => {
                if (val !== undefined) {
                    arr.push(val);
                }
                return arr;
            }, []);
            this.props.onChange(formData);
        };
        this.state = this.getInitialState(props);
    }
    getInitialState(props) {
        let { groups } = utils_1.getUiOptions(props.uiSchema) || [];
        const { formData } = props;
        const trueValues = groups.map(group => group.trueValue);
        const falseValues = groups.map(group => group.falseValue);
        const groupsFormData = [];
        if (formData) {
            formData.forEach(value => {
                if (value === undefined) {
                    return;
                }
                const trueIndex = trueValues.findIndex(trueValue => props.formContext.utils.formDataEquals(value, trueValue, props.idSchema.$id));
                if (trueIndex !== -1) {
                    groupsFormData[trueIndex] = value;
                }
                else {
                    const falseIndex = falseValues.findIndex(falseValue => props.formContext.utils.formDataEquals(value, falseValue, props.idSchema.$id));
                    if (falseIndex !== -1) {
                        groupsFormData[falseIndex] = value;
                    }
                }
            });
        }
        return { groupsFormData: groupsFormData };
    }
    render() {
        const TitleFieldTemplate = utils_2.getTemplate("TitleFieldTemplate", this.props.registry, utils_1.getUiOptions(this.props.uiSchema));
        let { groups } = utils_1.getUiOptions(this.props.uiSchema) || [];
        return (React.createElement(React.Fragment, null,
            React.createElement(TitleFieldTemplate, { title: this.props.schema.title, schema: this.props.schema, uiSchema: this.props.uiSchema, registry: this.props.registry }),
            React.createElement("div", { className: "checkbox-row" }, groups.map((group, idx) => {
                const { "ui:help": help, "ui:helpHoverable": helpHoverable, helpPlacement } = group, _group = __rest(group, ["ui:help", "ui:helpHoverable", "helpPlacement"]);
                const groupProps = Object.assign(Object.assign({}, this.props), { schema: Object.assign(Object.assign({}, this.props.schema.items), { title: group.label }), uiSchema: Object.assign(Object.assign({}, this.props.uiSchema), { "ui:options": Object.assign({ falseValue: undefined }, _group), "ui:help": help, "ui:helpHoverable": helpHoverable, "ui:helpPlacement": helpPlacement }), formData: this.state.groupsFormData[idx], onChange: this.onChange(idx) });
                return (React.createElement(React.Fragment, { key: idx },
                    React.createElement(AnyToBooleanField_1.default, Object.assign({}, groupProps))));
            }))));
    }
};
MultiAnyToBooleanField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            groups: PropTypes.arrayOf(PropTypes.shape({
                label: PropTypes.string,
                trueValue: PropTypes.any,
                falseValue: PropTypes.any,
                allowUndefined: PropTypes.bool
            }))
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.array
};
MultiAnyToBooleanField = __decorate([
    BaseComponent_1.default
], MultiAnyToBooleanField);
exports.default = MultiAnyToBooleanField;
