"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const BaseComponent_1 = require("../BaseComponent");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
let MultiLanguageField = class MultiLanguageField extends React.Component {
    constructor(props) {
        super(props);
        this.onChange = (lang) => (formData) => {
            const newFormData = Object.assign(Object.assign({}, this.props.formData), { [lang]: formData });
            this.props.onChange(newFormData);
        };
    }
    render() {
        const SchemaField = this.props.registry.fields.SchemaField;
        const { Label, lang } = this.props.formContext;
        const { schema, uiSchema, idSchema, errorSchema, formData = {}, required } = this.props;
        const uiOptions = utils_1.getUiOptions(uiSchema);
        const languages = Object.keys(schema.properties).sort((a, b) => {
            const sortA = Number(a !== lang);
            const sortB = Number(b !== lang);
            return sortA - sortB;
        });
        return (React.createElement(React.Fragment, null,
            React.createElement(Label, { label: schema.title || "", required: required || uiSchema["ui:required"], uiSchema: uiSchema }),
            languages.map(_lang => {
                var _a;
                return (React.createElement(SchemaField, Object.assign({}, this.props, { key: _lang, schema: Object.assign({ title: "" }, schema.properties[_lang]), uiSchema: {
                        "ui:widget": "InputGroupWidget",
                        "ui:options": Object.assign({ "inputGroupText": _lang, "className": "multi-lang-input-group" }, uiOptions)
                    }, errorSchema: errorSchema[_lang] || {}, idSchema: idSchema[_lang], formData: formData[_lang] || "", required: ((_a = uiSchema[_lang]) === null || _a === void 0 ? void 0 : _a["ui:required"]) || false, onChange: this.onChange(_lang) })));
            })));
    }
};
MultiLanguageField.propTypes = {
    uiSchema: PropTypes.any,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired,
    formData: PropTypes.object
};
MultiLanguageField = __decorate([
    BaseComponent_1.default
], MultiLanguageField);
exports.default = MultiLanguageField;
