"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
let PrefillingArrayField = class PrefillingArrayField extends React.Component {
    constructor() {
        super(...arguments);
        this.mapFormData = (formData) => {
            const prefiller = formData.prefiller;
            return (formData.rest && formData.rest.length
                ? formData.rest
                : [utils_1.getDefaultFormState(this.props.schema.items)]).map(item => {
                return Object.assign(Object.assign({}, item), { [this.getUiOptions().field]: prefiller });
            });
        };
        this.onChange = (formData) => {
            this.props.onChange(this.mapFormData(formData));
        };
    }
    static getName() { return "PrefillingArrayField"; }
    getStateFromProps(props) {
        const { field, uiSchema } = this.getUiOptions();
        return Object.assign(Object.assign({}, props), { schema: {
                type: "object",
                title: "",
                properties: {
                    prefiller: props.schema.items.properties[field],
                    rest: props.schema
                }
            }, uiSchema: {
                prefiller: uiSchema || props.uiSchema.items[field],
                rest: props.formData && props.formData.length ? props.uiSchema : Object.assign(Object.assign({}, props.uiSchema), { "ui:options": Object.assign(Object.assign({}, props.uiSchema["ui:options"]), { canAdd: false }) }),
            }, formData: {
                prefiller: ((props.formData || [])[0] || {})[field],
                rest: props.formData
            }, idSchema: {
                prefiller: { prefiller: `${props.idSchema.$id}_${field}` },
                rest: props.idSchema
            }, onChange: this.onChange });
    }
};
PrefillingArrayField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            field: PropTypes.string,
            uiSchema: PropTypes.object
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.array.isRequired
};
PrefillingArrayField = __decorate([
    VirtualSchemaField_1.default
], PrefillingArrayField);
exports.default = PrefillingArrayField;
