"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const BaseComponent_1 = require("../BaseComponent");
const NestField_1 = require("./NestField");
const ReactContext_1 = require("../../ReactContext");
const utils_2 = require("@rjsf/utils");
let SplitField = class SplitField extends React.Component {
    constructor() {
        super(...arguments);
        this.renderSplitField = ({ fields }) => {
            const { SchemaField } = this.props.registry.fields;
            // TODO TS fix typing after NestField ts conversion.
            const _props = NestField_1.getPropsForFields(this.props, fields);
            return (React.createElement(SchemaField, Object.assign({}, this.props, _props, { onChange: this.onChange(fields), name: "" })));
        };
        this.onChange = (fields) => (formData) => {
            this.props.onChange(fields.reduce((updatedFormData, field) => {
                return Object.assign(Object.assign({}, updatedFormData), { [field]: formData[field] });
            }, this.props.formData));
        };
    }
    render() {
        const TitleFieldTemplate = utils_2.getTemplate("TitleFieldTemplate", this.props.registry, utils_1.getUiOptions(this.props.uiSchema));
        const DescriptionFieldTemplate = utils_2.getTemplate("DescriptionFieldTemplate", this.props.registry, utils_1.getUiOptions(this.props.uiSchema));
        const { "ui:title": _title } = this.props.uiSchema;
        const { Row, Col } = this.context.theme;
        return (React.createElement("div", null,
            React.createElement(TitleFieldTemplate, { id: `${this.props.idSchema.$id}__title`, title: _title !== undefined ? _title : this.props.title, required: this.props.required || this.props.uiSchema["ui:required"], schema: this.props.schema, uiSchema: this.props.uiSchema, registry: this.props.registry }),
            React.createElement(DescriptionFieldTemplate, { id: `${this.props.idSchema.$id}__description`, schema: this.props.schema, description: this.props.description, registry: this.props.registry }),
            React.createElement(Row, null, utils_1.getUiOptions(this.props.uiSchema).splits.map((split, i) => React.createElement(Col, { md: split.md, lg: split.lg, xs: split.xs, sm: split.sm, key: i }, this.renderSplitField(split))))));
    }
};
SplitField.contextType = ReactContext_1.default;
SplitField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            splits: PropTypes.arrayOf(PropTypes.shape({
                fields: PropTypes.arrayOf(PropTypes.string).isRequired,
                uiSchema: PropTypes.object,
                name: PropTypes.string,
                lg: PropTypes.number,
                md: PropTypes.number,
                sm: PropTypes.number,
                xs: PropTypes.number
            })).isRequired
        }).isRequired
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired,
    formData: PropTypes.object.isRequired
};
SplitField = __decorate([
    BaseComponent_1.default
], SplitField);
exports.default = SplitField;
