"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
const utils_1 = require("../../utils");
let StringToArrayField = class StringToArrayField extends React.Component {
    constructor() {
        super(...arguments);
        this.onChange = (formData) => {
            const { delimiter = " " } = this.getUiOptions();
            this.props.onChange(formData.filter(v => v).join(delimiter));
        };
    }
    static getName() { return "StringToArrayField"; }
    getStateFromProps(props) {
        const { formData = "" } = props;
        const { delimiter = " " } = this.getUiOptions();
        const { "ui:disabled": disabled, "ui:readonly": readonly } = props.uiSchema;
        const innerUiSchema = utils_1.getInnerUiSchema(props.uiSchema);
        return {
            schema: {
                type: "array",
                title: props.schema.title,
                items: Object.assign(Object.assign({}, props.schema), { title: "" })
            },
            formData: formData.split(delimiter),
            uiSchema: Object.assign({ "ui:disabled": disabled, "ui:readonly": readonly }, innerUiSchema),
            onChange: this.onChange
        };
    }
};
StringToArrayField.propTypes = {
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string"])
    }).isRequired,
    formData: PropTypes.string
};
StringToArrayField = __decorate([
    VirtualSchemaField_1.default
], StringToArrayField);
exports.default = StringToArrayField;
