"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
const sumPropType = PropTypes.shape({
    resultField: PropTypes.string.isRequired,
    summedFields: PropTypes.arrayOf(PropTypes.string).isRequired,
    summedProperty: PropTypes.string
});
let SumField = class SumField extends React.Component {
    constructor() {
        super(...arguments);
        this.onChange = (formData) => {
            let { sums } = this.getUiOptions();
            sums = Array.isArray(sums) ? sums : [sums];
            const newSums = this.getSums(formData);
            sums.forEach(options => {
                if (newSums[options.resultField] !== this.state.prevResult[options.resultField]) {
                    formData = Object.assign(Object.assign({}, formData), { [options.resultField]: newSums[options.resultField] });
                }
            });
            this.props.onChange(formData);
        };
        this.getSums = (formData) => {
            let { sums } = this.getUiOptions();
            sums = Array.isArray(sums) ? sums : [sums];
            const results = {};
            sums.forEach(options => {
                const { resultField, summedFields, summedProperty } = options;
                const resultType = this.props.schema.properties[resultField].type;
                let result = 0;
                let allEmpty = true;
                summedFields.forEach(field => {
                    if (formData[field] !== undefined) {
                        if (summedProperty === "arrayLength") {
                            result += formData[field].length;
                        }
                        else {
                            result += Number(formData[field]);
                        }
                        allEmpty = false;
                    }
                });
                result = allEmpty || isNaN(result) ? undefined : result;
                if (result !== undefined && resultType !== "number" && resultType !== "integer") {
                    result = result + "";
                }
                results[resultField] = result;
            });
            return results;
        };
    }
    static getName() { return "SumField"; }
    getStateFromProps({ formData }) {
        return { prevResult: this.getSums(formData), onChange: this.onChange };
    }
};
SumField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            "sums": PropTypes.oneOfType([
                sumPropType,
                PropTypes.arrayOf(sumPropType)
            ]).isRequired
        }),
        uiSchema: PropTypes.object
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object"])
    }).isRequired,
    formData: PropTypes.object.isRequired
};
SumField = __decorate([
    VirtualSchemaField_1.default
], SumField);
exports.default = SumField;
