"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const BaseComponent_1 = require("../BaseComponent");
const Context_1 = require("../../Context");
let ToggleAdditionalArrayFieldsField = class ToggleAdditionalArrayFieldsField extends React.Component {
    constructor(props) {
        super(props);
        this.getTogglePersistenceContextKey = (props) => `$additional_toggle_persistence_${props.idSchema.$id}`;
        this.toggleVisibility = () => {
            const visible = !this.state.visible;
            const context = Context_1.default(this.props.formContext.contextId);
            context[this.getTogglePersistenceContextKey(this.props)] = visible;
            this.setState({ visible });
        };
        this.state = Object.assign({ visible: this.getInitialVisible(props) }, this.getStateFromProps(props));
    }
    getInitialVisible(props) {
        const { additionalFields } = utils_1.getUiOptions(props.uiSchema);
        const context = Context_1.default(props.formContext.contextId);
        let visible = context[this.getTogglePersistenceContextKey(props)] || false;
        if (!visible) {
            for (const data of props.formData) {
                for (const field of additionalFields) {
                    if (!utils_1.isDefaultData(utils_1.parseJSONPointer(data, field), utils_1.parseSchemaFromFormDataPointer(props.schema, field))) {
                        visible = true;
                        break;
                    }
                }
            }
        }
        return visible;
    }
    getStateFromProps(props) {
        const innerUiSchema = utils_1.getInnerUiSchema(props.uiSchema);
        return { uiSchema: innerUiSchema };
    }
    render() {
        const { CheckboxWidget } = this.props.registry.widgets;
        const { SchemaField } = this.props.registry.fields;
        const { additionalFields = [], toggleLabel, toggleClassName, toggleHelp } = utils_1.getUiOptions(this.props.uiSchema);
        const shouldShow = Object.values(this.props.errorSchema || {}).some(error => additionalFields.some(field => utils_1.parseJSONPointer(error, field))) || this.state.visible;
        let _uiSchema = this.state.uiSchema;
        if (!shouldShow) {
            additionalFields.forEach(field => {
                _uiSchema = utils_1.updateSafelyWithJSONPointer(_uiSchema, { "ui:field": "HiddenField" }, "items/" + field);
            });
        }
        return (React.createElement(React.Fragment, null,
            React.createElement(SchemaField, Object.assign({}, this.props, { uiSchema: _uiSchema })),
            React.createElement("div", { className: toggleClassName },
                React.createElement(CheckboxWidget, Object.assign({}, this.props, { id: this.props.idSchema.$id + "_toggle", schema: { type: "boolean" }, value: this.state.visible, onChange: this.toggleVisibility, label: toggleLabel || "", options: { allowUndefined: false, help: toggleHelp }, required: false })))));
    }
};
ToggleAdditionalArrayFieldsField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            additionalFields: PropTypes.arrayOf(PropTypes.string).isRequired,
            toggleLabel: PropTypes.string,
            toggleClassName: PropTypes.string,
            toggleHelp: PropTypes.string
        }),
        uiSchema: PropTypes.object
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.array]).isRequired
};
ToggleAdditionalArrayFieldsField = __decorate([
    BaseComponent_1.default
], ToggleAdditionalArrayFieldsField);
exports.default = ToggleAdditionalArrayFieldsField;
