"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const Context_1 = require("../../Context");
const utils_1 = require("../../utils");
const react_inlinesvg_1 = require("react-inlinesvg");
const SelectWidget_1 = require("./SelectWidget");
const BaseComponent_1 = require("../BaseComponent");
let ImageSelectWidget = class ImageSelectWidget extends React.Component {
    constructor(props) {
        super(props);
        this.renderImg = (enumName, fallback) => {
            const imgName = utils_1.getUiOptions(this.props).images[enumName];
            if (imgName === undefined)
                return fallback;
            let path = this._context[enumName] || {};
            try {
                path.svg = `https://cdn.laji.fi/images/${imgName}.svg`;
                path.png = `https://cdn.laji.fi/images/${imgName}.png`;
            }
            finally {
                this._context[enumName] = path;
                return React.createElement("span", { className: "select-icon" },
                    React.createElement(react_inlinesvg_1.default, { key: enumName, src: path.svg, cacheGetRequests: true },
                        React.createElement("img", { src: path.png })));
            }
        };
        this._context = Context_1.default("IMAGES");
    }
    render() {
        return (React.createElement(SelectWidget_1.default, Object.assign({}, this.props, { selectProps: {
                renderValue: item => this.renderImg(item.value, item.label),
                renderOption: item => React.createElement("div", null,
                    this.renderImg(item.value, item.label),
                    " ",
                    React.createElement("span", null, item.label))
            } })));
    }
};
ImageSelectWidget.propTypes = {
    options: PropTypes.object.isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string"])
    }),
    value: PropTypes.string
};
ImageSelectWidget = __decorate([
    BaseComponent_1.default
], ImageSelectWidget);
exports.default = ImageSelectWidget;
