"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const BaseInputTemplate_1 = require("../templates/BaseInputTemplate");
const ReactContext_1 = require("../../ReactContext");
const utils_1 = require("../../utils");
const TextareaWidget_1 = require("./TextareaWidget");
class InputGroupWidget extends React.Component {
    render() {
        const { InputGroup } = this.context.theme;
        const { inputGroupText = "", inputType = "basic", className = "" } = utils_1.getUiOptions(this.props);
        const input = inputType === "textarea" ? React.createElement(TextareaWidget_1.default, Object.assign({}, this.props)) : React.createElement(BaseInputTemplate_1.default, Object.assign({}, this.props));
        return (React.createElement(InputGroup, { key: inputGroupText, className: utils_1.classNames("input-group-widget", `input-group-${inputType}`, className) },
            React.createElement(InputGroup.Addon, { className: "input-group-text" },
                inputGroupText,
                this.props.required && React.createElement("span", { className: "text-danger" }, "*")),
            input));
    }
}
exports.default = InputGroupWidget;
InputGroupWidget.contextType = ReactContext_1.default;
InputGroupWidget.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            inputGroupText: PropTypes.string,
            inputType: PropTypes.oneOf(["basic", "textarea"]),
            className: PropTypes.string
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string", "number", "integer"]),
    }).isRequired,
    value: PropTypes.string,
    required: PropTypes.bool
};
