"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const BaseInputTemplate_1 = require("../templates/BaseInputTemplate");
const ReactContext_1 = require("../../ReactContext");
const utils_1 = require("../../utils");
class InputWithDefaultValueButtonWidget extends React.Component {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { contextFieldForDefaultValue, onClick } = utils_1.getUiOptions(this.props);
            if (contextFieldForDefaultValue) {
                const uiSchemaContext = this.props.formContext.uiSchemaContext || {};
                const defaultValue = uiSchemaContext[contextFieldForDefaultValue];
                this.props.onChange(defaultValue);
            }
            if (onClick) {
                onClick();
            }
        };
    }
    render() {
        const { InputGroup, Button } = this.context.theme;
        const { buttonLabel } = utils_1.getUiOptions(this.props);
        const { disabled, readonly } = this.props;
        return (React.createElement(InputGroup, null,
            React.createElement(BaseInputTemplate_1.default, Object.assign({}, this.props)),
            React.createElement(InputGroup.Button, { className: "input-group-button" },
                React.createElement(Button, { onClick: this.onClick, disabled: disabled || readonly }, buttonLabel))));
    }
}
exports.default = InputWithDefaultValueButtonWidget;
InputWithDefaultValueButtonWidget.contextType = ReactContext_1.default;
InputWithDefaultValueButtonWidget.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            buttonLabel: PropTypes.string.isRequired,
            contextFieldForDefaultValue: PropTypes.string,
            onClick: PropTypes.func
        }).isRequired
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string", "number", "integer"]),
    }).isRequired,
    value: PropTypes.string
};
