"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
class TaxonImageWidget extends React.Component {
    constructor() {
        super(...arguments);
        this.onTaxonImageClick = (taxonID) => () => {
            this.props.onChange(taxonID);
        };
    }
    render() {
        const { SchemaField } = this.props.registry.fields;
        const { uiSchema } = utils_1.getUiOptions(this.props);
        const schemaField = uiSchema
            ? React.createElement(SchemaField, Object.assign({}, this.props, { schema: Object.assign(Object.assign({}, this.props.schema), { title: "" }), uiSchema: Object.assign(Object.assign({}, uiSchema), { "ui:title": "" }) }))
            : null;
        return (React.createElement(React.Fragment, null,
            ["MX.45", "MX.255"].map(taxonID => React.createElement("div", { key: taxonID, style: { height: 100, width: 100 }, onClick: this.onTaxonImageClick(taxonID) })),
            schemaField));
    }
}
exports.default = TaxonImageWidget;
TaxonImageWidget.propTypes = {
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string"])
    }).isRequired,
    value: PropTypes.string
};
