import LajiMapType from "laji-map/lib/map";
import { Options } from "laji-map";
/**
 * Service used for accessing a singlet on instance of LajiMap. Using a singleton instance increases performance, as
 * the map needs to be initialized only once. Control of the map of simply grabbed, making the previous owner lose
 * control of the map.
 */
export default class SingletonMapService {
    map: LajiMapType;
    private owner;
    destroy(): void;
    /**
     * Grab control of the singleton map.
     * @param instance should be the Map component instance, that is set as the controller of the map.
     * @param mapOptions Map options to set to the map.
     */
    grab(instance: any, mapOptions: Options): LajiMapType;
    release(instance: any): void;
    /**
     * Ask whether given instance has control of the map.
     */
    amOwner(instance: any): boolean;
}
