"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const _Panel = require("react-bootstrap/lib/Panel");
const Table = require("react-bootstrap/lib/Table");
const ProgressBar = require("react-bootstrap/lib/ProgressBar");
const Button = require("react-bootstrap/lib/Button");
const ButtonGroup = require("react-bootstrap/lib/ButtonGroup");
const ButtonToolbar = require("react-bootstrap/lib/ButtonToolbar");
const Overlay = require("react-bootstrap/lib/Overlay");
const _OverlayTrigger = require("react-bootstrap/lib/OverlayTrigger");
const Popover = require("react-bootstrap/lib/Popover");
const Tooltip = require("react-bootstrap/lib/Tooltip");
const Glyphicon = require("react-bootstrap/lib/Glyphicon");
const Modal = require("react-bootstrap/lib/Modal");
const Row = require("react-bootstrap/lib/Row");
const Col = require("react-bootstrap/lib/Col");
const FormGroup = require("react-bootstrap/lib/FormGroup");
const InputGroup = require("react-bootstrap/lib/InputGroup");
const FormControl = require("react-bootstrap/lib/FormControl");
const ListGroup = require("react-bootstrap/lib/ListGroup");
const ListGroupItem = require("react-bootstrap/lib/ListGroupItem");
const Breadcrumb = require("react-bootstrap/lib/Breadcrumb");
const HelpBlock = require("react-bootstrap/lib/HelpBlock");
const MenuItem = require("react-bootstrap/lib/MenuItem");
const Alert = require("react-bootstrap/lib/Alert");
const Pager = require("react-bootstrap/lib/Pager");
const Accordion = require("react-bootstrap/lib/Accordion");
const Collapse = require("react-bootstrap/lib/Collapse");
const Dropdown = require("react-bootstrap/lib/Dropdown");
const Form = require("react-bootstrap/lib/Form");
const ControlLabel = require("react-bootstrap/lib/ControlLabel");
const Checkbox = require("react-bootstrap/lib/Checkbox");
const ToggleButton = require("react-bootstrap/lib/ToggleButton");
const ToggleButtonGroup = require("react-bootstrap/lib/ToggleButtonGroup");
const mapBtnVariant = (variant) => {
    return variant === null || variant === void 0 ? void 0 : variant.replace("outline-", "");
};
const Panel = React.forwardRef((_a, ref) => {
    var { variant } = _a, props = __rest(_a, ["variant"]);
    return React.createElement(_Panel, Object.assign({}, props, { bsStyle: variant, ref: ref }));
});
const __Panel = Panel;
__Panel.Body = _Panel.Body;
__Panel.Heading = _Panel.Heading;
__Panel.Collapse = _Panel.Collapse;
__Panel.Footer = _Panel.Footer;
// Wrapper needed or webpack will hang.
const _Dropdown = (props) => React.createElement(Dropdown, Object.assign({}, props));
const __Dropdown = _Dropdown;
__Dropdown.Menu = React.forwardRef((props, ref) => React.createElement(Dropdown.Menu, Object.assign({}, props, { ref: ref })));
__Dropdown.Menu.defaultProps = { bsRole: "menu" };
__Dropdown.Toggle = React.forwardRef((_a, ref) => {
    var { variant } = _a, props = __rest(_a, ["variant"]);
    return React.createElement(Dropdown.Toggle, Object.assign({ bsStyle: variant }, props, { ref: ref }));
});
__Dropdown.Toggle.defaultProps = { bsRole: "toggle" };
const _Breadcrumb = Breadcrumb;
_Breadcrumb.Item = Breadcrumb.Item;
function usePreviousValue(value) {
    const ref = React.useRef();
    React.useEffect(() => {
        ref.current = value;
    });
    return ref.current;
}
const OverlayTrigger = (props) => {
    const { show } = props, _props = __rest(props, ["show"]);
    const prevShow = usePreviousValue(show);
    const ref = React.useRef();
    React.useEffect(() => {
        if (show && !prevShow) {
            ref.current.show();
        }
        else if (!show && prevShow) {
            ref.current.hide();
        }
    }, [show, prevShow]);
    return (React.createElement(_OverlayTrigger, Object.assign({}, _props, { ref: ref })));
};
const theme = {
    Panel: __Panel,
    Table,
    ProgressBar,
    Button: React.forwardRef((_a, ref) => {
        var { variant, small } = _a, props = __rest(_a, ["variant", "small"]);
        return React.createElement(Button, Object.assign({}, props, { bsStyle: mapBtnVariant(variant), bsSize: small ? "small" : undefined, ref: ref }));
    }),
    ButtonGroup,
    ButtonToolbar,
    Overlay,
    OverlayTrigger,
    // OverlayTrigger: React.forwardRef<OverlayTrigger, OverlayTriggerProps>(({show, ...props}, ref) => <OverlayTrigger {...props} ref={ref} />),
    Popover,
    Tooltip,
    Glyphicon,
    Modal,
    Row,
    Col,
    FormGroup,
    InputGroup,
    FormControl,
    ListGroup,
    ListGroupItem,
    Breadcrumb: _Breadcrumb,
    HelpBlock,
    MenuItem,
    Alert: (_a) => {
        var { variant } = _a, props = __rest(_a, ["variant"]);
        return React.createElement(Alert, Object.assign({}, props, { bsStyle: variant }));
    },
    Pager,
    Accordion,
    Collapse,
    Dropdown: __Dropdown,
    Form,
    ControlLabel,
    Checkbox,
    ToggleButton,
    ToggleButtonGroup
};
exports.default = theme;
