"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const Stub = ({ children }) => {
    console.error("You should define a theme prop for LajiForm. Using stub theme, the form will render but many components won't work as expected and will result in many React warnings.");
    return React.createElement(React.Fragment, null, children);
};
const DivStub = React.forwardRef((props, ref) => React.createElement(Stub, null,
    React.createElement("div", Object.assign({}, props, { ref: ref }))));
const Panel = DivStub;
Panel.Body = DivStub;
Panel.Heading = DivStub;
Panel.Collapse = DivStub;
const Modal = DivStub;
Modal.Body = DivStub;
Modal.Header = DivStub;
Modal.Footer = DivStub;
Modal.Title = DivStub;
const InputGroup = DivStub;
InputGroup.Addon = DivStub;
InputGroup.Button = DivStub;
const Breadcrumb = DivStub;
Breadcrumb.Item = DivStub;
const Pager = DivStub;
Breadcrumb.Item = DivStub;
const Dropdown = DivStub;
Dropdown.Menu = DivStub;
const theme = {
    Panel,
    Table: DivStub,
    ProgressBar: DivStub,
    Button: React.forwardRef((props, ref) => React.createElement(Stub, null,
        React.createElement("button", Object.assign({}, props, { ref: ref })))),
    ButtonGroup: DivStub,
    ButtonToolbar: DivStub,
    Overlay: DivStub,
    OverlayTrigger: React.forwardRef((props, ref) => React.createElement(Stub, null,
        React.createElement("div", Object.assign({}, props, { ref: ref })))),
    Popover: (_a) => {
        var { title } = _a, props = __rest(_a, ["title"]);
        return React.createElement(Stub, null,
            React.createElement("div", Object.assign({}, props)));
    },
    Tooltip: DivStub,
    Glyphicon: DivStub,
    Modal,
    Row: DivStub,
    Col: DivStub,
    FormGroup: DivStub,
    InputGroup,
    FormControl: (props) => React.createElement("input", Object.assign({}, props)),
    ListGroup: DivStub,
    ListGroupItem: DivStub,
    Breadcrumb: Breadcrumb,
    HelpBlock: DivStub,
    MenuItem: DivStub,
    Alert: DivStub,
    Pager,
    Accordion: DivStub,
    Collapse: DivStub,
    Dropdown,
    Form: DivStub,
    ControlLabel: DivStub,
    Checkbox: (props) => React.createElement("input", Object.assign({ type: "checkbox" }, props)),
    ToggleButton: DivStub,
    ToggleButtonGroup: React.forwardRef((_a, ref) => {
        var { defaultValue } = _a, props = __rest(_a, ["defaultValue"]);
        return React.createElement("input", Object.assign({ defaultChecked: defaultValue }, props, { ref: ref }));
    })
};
exports.default = theme;
