"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_utils_1 = require("./test-utils");
const protractor_1 = require("protractor");
describe("dataset form (MHL.731)", () => {
    let form;
    let nameInEnglishInput$;
    let nameInFinnishInput$;
    const uiSchemaContext = {
        defaultPersonsResponsible: "Test, User"
    };
    beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
        form = yield test_utils_1.createForm({ id: "MHL.731" });
        yield form.setState({ uiSchemaContext });
        nameInEnglishInput$ = form.$locate("datasetName_en").$("input");
        nameInFinnishInput$ = form.$locate("datasetName_fi").$("input");
    }));
    it("sets correct name to dataset when adding a name in one language", () => __awaiter(void 0, void 0, void 0, function* () {
        const name = "name";
        yield nameInEnglishInput$.sendKeys(name + protractor_1.protractor.Key.TAB);
        const formData = yield form.getChangedData();
        expect(formData.datasetName["en"]).toBe(name);
    }));
    it("sets correct name to dataset when adding a name in two languages", () => __awaiter(void 0, void 0, void 0, function* () {
        const name1 = "name in English";
        const name2 = "name in Finnish";
        yield nameInEnglishInput$.clear();
        yield nameInEnglishInput$.sendKeys(name1);
        yield nameInFinnishInput$.sendKeys(name2 + protractor_1.protractor.Key.TAB);
        const formData = yield form.getChangedData();
        expect(formData.datasetName["en"]).toBe(name1);
        expect(formData.datasetName["fi"]).toBe(name2);
    }));
    it("sets correct name to personsResponsible field when clicking a me button", () => __awaiter(void 0, void 0, void 0, function* () {
        yield form.$locate("personsResponsible").$("button").click();
        const $input = form.$locate("personsResponsible").$("input");
        expect(yield $input.getAttribute("value")).toBe("Test, User");
        const formData = yield form.getChangedData();
        expect(formData.personsResponsible).toBe("Test, User");
    }));
});
