"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_utils_1 = require("./test-utils");
const protractor_1 = require("protractor");
describe("SYKE butterfly form (MHL.59)", () => {
    let form;
    let $firstUnitsAdd;
    let $secondUnitsAdd;
    let $gatheringsAdd;
    it("navigate to form", () => __awaiter(void 0, void 0, void 0, function* () {
        const formData = {
            "gatherings": [
                {
                    "section": 1,
                    "units": []
                },
                {
                    "units": []
                }
            ]
        };
        form = yield test_utils_1.createForm({ id: "MHL.59", formData });
        const $$addButtons = yield form.$locate("gatherings.0.units").$$("button");
        $firstUnitsAdd = $$addButtons[0];
        $secondUnitsAdd = $$addButtons[1];
        $gatheringsAdd = form.$locateButton("gatherings", "add");
        //$lastGatheringsUnitsAdd = form.$locateButton("gatherings.1.units", "add");
    }));
    it("has gatherings", () => __awaiter(void 0, void 0, void 0, function* () {
        expect(yield form.$locate("gatherings").isDisplayed()).toBe(true);
    }));
    it("has one gathering by default", () => __awaiter(void 0, void 0, void 0, function* () {
        expect(yield form.$locate("gatherings.0").isDisplayed()).toBe(true);
    }));
    it("has gatherings add", () => __awaiter(void 0, void 0, void 0, function* () {
        expect(yield $gatheringsAdd.isDisplayed()).toBe(true);
    }));
    it("has first unit add", () => __awaiter(void 0, void 0, void 0, function* () {
        expect(yield $firstUnitsAdd.isDisplayed()).toBe(true);
    }));
    it("has second unit add", () => __awaiter(void 0, void 0, void 0, function* () {
        expect(yield $secondUnitsAdd.isDisplayed()).toBe(true);
    }));
    describe("adding unit to first group", () => {
        it("works", () => __awaiter(void 0, void 0, void 0, function* () {
            yield $firstUnitsAdd.click();
            expect(yield form.$locate("gatherings.0.units.0.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.individualCount").isDisplayed()).toBe(true);
        }));
        it("autofocuses", () => __awaiter(void 0, void 0, void 0, function* () {
            expect(yield test_utils_1.getFocusedId()).toBe(yield form.$getInputWidget("gatherings.0.units.0.identifications.0.taxonVerbatim").getAttribute("id"));
        }));
    });
    describe("adding unit to second group", () => {
        it("works", () => __awaiter(void 0, void 0, void 0, function* () {
            yield $secondUnitsAdd.click();
            expect(yield form.$locate("gatherings.0.units.0.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.individualCount").isDisplayed()).toBe(true);
        }));
        it("autofocuses", () => __awaiter(void 0, void 0, void 0, function* () {
            expect(yield test_utils_1.getFocusedId()).toBe(yield form.$getInputWidget("gatherings.0.units.1.identifications.0.taxonVerbatim").getAttribute("id"));
        }));
    });
    describe("adding new section", () => {
        it("works", () => __awaiter(void 0, void 0, void 0, function* () {
            yield $gatheringsAdd.click();
            yield form.$locateAddition("gatherings", "section-input").sendKeys("2");
            yield form.$locateAddition("gatherings", "section-input").sendKeys(protractor_1.protractor.Key.ENTER);
            expect(yield form.$locate("gatherings.0.units.1.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.1.individualCount").isDisplayed()).toBe(true);
        }));
        // Works really but test suite fails
        //it("autofocuses", async () => {
        //	expect(await getFocusedId() === await form.$getInputWidget("gatherings.1.gatheringFact.sykeButterFlyCensusWind").getAttribute("id")).toBe(true);
        //});
    });
    describe("adding unit to first group again", () => {
        it("works", () => __awaiter(void 0, void 0, void 0, function* () {
            yield $firstUnitsAdd.click();
            expect(yield form.$locate("gatherings.0.units.0.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.2.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.2.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.2.individualCount").isDisplayed()).toBe(true);
        }));
        it("autofocuses", () => __awaiter(void 0, void 0, void 0, function* () {
            expect(yield test_utils_1.getFocusedId()).toBe(yield form.$getInputWidget("gatherings.0.units.1.identifications.0.taxonVerbatim").getAttribute("id"));
        }));
    });
    describe("adding unit to second group again", () => {
        it("works", () => __awaiter(void 0, void 0, void 0, function* () {
            yield $secondUnitsAdd.click();
            expect(yield form.$locate("gatherings.0.units.0.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.2.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.3.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.2.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.3.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.2.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.3.individualCount").isDisplayed()).toBe(true);
        }));
        it("autofocuses", () => __awaiter(void 0, void 0, void 0, function* () {
            expect(yield test_utils_1.getFocusedId()).toBe(yield form.$getInputWidget("gatherings.0.units.3.identifications.0.taxonVerbatim").getAttribute("id"));
        }));
    });
    describe("adding new section again", () => {
        it("works", () => __awaiter(void 0, void 0, void 0, function* () {
            yield $gatheringsAdd.click();
            yield form.$locateAddition("gatherings", "section-input").sendKeys("3");
            yield form.$locateAddition("gatherings", "section-input").sendKeys(protractor_1.protractor.Key.ENTER);
            expect(yield form.$locate("gatherings.0.units.0.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.2.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.3.identifications.0.taxonVerbatim").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.2.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.3.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.2.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.1.units.3.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.2.units.0.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.2.units.1.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.2.units.2.individualCount").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.2.units.3.individualCount").isDisplayed()).toBe(true);
        }));
        // Works really but test suite fails
        //it("autofocuses", async () => {
        //	expect(await getFocusedId() === await form.$getInputWidget("gatherings.2.gatheringFact.sykeButterFlyCensusWind").getAttribute("id")).toBe(true);
        //});
    });
    it("removing new section works", () => __awaiter(void 0, void 0, void 0, function* () {
        const gatheringsLength = (yield form.getChangedData()).gatherings.length;
        yield form.$locateButton("gatherings.0", "delete").click();
        const formData = yield form.getChangedData();
        expect(formData.gatherings.length).not.toBe(gatheringsLength);
        expect(formData.gatherings[0].section).toBe(2);
        expect(formData.gatherings[formData.gatherings.length - 1].section).toBe(undefined);
    }));
});
