"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.maybeJSONPointerToLocator = exports.filterUUIDs = exports.mockImageMetadata = exports.updateValue = exports.removeUnit = exports.putForeignMarkerToMap = exports.waitUntilBlockingLoaderHides = exports.createForm = exports.NamedPlaceChooserPO = exports.isDisplayed = exports.Form = exports.getFocusedId = exports.getFocusedElement = exports.lajiFormLocate = exports.lajiFormLocator = exports.navigateToForm = exports.emptyForm = exports.getLocatorForContextId = exports.EC = void 0;
const protractor_1 = require("protractor");
const path = require("path");
const { HOST, PORT } = process.env;
exports.EC = protractor_1.protractor.ExpectedConditions;
const getLocatorForContextId = (contextId) => (path) => `#_laji-form_${contextId}_root${typeof path === "string" && path.length ? `_${path.replace(/\./g, "_")}` : ""}`;
exports.getLocatorForContextId = getLocatorForContextId;
const emptyForm = (params = "") => __awaiter(void 0, void 0, void 0, function* () { return protractor_1.browser.get(`http://${HOST}:${PORT}?test=true&settings=false&mockApi=true&${params}`); });
exports.emptyForm = emptyForm;
const navigateToForm = (formID, params = "") => __awaiter(void 0, void 0, void 0, function* () { return protractor_1.browser.get(`http://${HOST}:${PORT}?id=${formID}&local=true&settings=false&mockApi=true${params}`); });
exports.navigateToForm = navigateToForm;
exports.lajiFormLocator = exports.getLocatorForContextId(0);
const lajiFormLocate = (str) => protractor_1.$(exports.lajiFormLocator(str));
exports.lajiFormLocate = lajiFormLocate;
const getFocusedElement = () => protractor_1.browser.driver.switchTo().activeElement();
exports.getFocusedElement = getFocusedElement;
const getFocusedId = () => exports.getFocusedElement().getAttribute("id");
exports.getFocusedId = getFocusedId;
function getEnumWidgetForContainer($container) {
    return {
        $container,
        openEnums: () => __awaiter(this, void 0, void 0, function* () {
            yield $container.click();
            yield protractor_1.browser.wait(protractor_1.protractor.ExpectedConditions.visibilityOf($container.$$(".rw-list-option").first()), 300, "select list timeout");
        }),
        $enumContainer: $container.$(".rw-popup-container"),
        $$enums: $container.$$(".rw-list-option"),
        $input: $container.$("input")
    };
}
class Form {
    constructor(params = {}) {
        this.$form = protractor_1.$(".laji-form  .rjsf");
        this.getMockStr = (path, query) => `window.mockResponses[window.getMockQueryKey(${JSON.stringify(path)}, ${JSON.stringify(query)})]`;
        this.createValidatorPO = (type) => ({
            $$all: protractor_1.$$(`.laji-form-error-list:not(.laji-form-failed-jobs-list) .${type}-panel .list-group button`),
            $panel: protractor_1.$(`.laji-form-error-list:not(.laji-form-failed-jobs-list) .${type}-panel`)
        });
        this.errors = this.createValidatorPO("error");
        this.warnings = this.createValidatorPO("warning");
        this.failedJobs = {
            $container: protractor_1.$(".laji-form-failed-jobs-list")
        };
        this.$acknowledgeWarnings = protractor_1.$(".laji-form-warning-list .panel-footer button");
        this.isBlocked = () => protractor_1.$(".laji-form.blocking-loader").isDisplayed();
        this.mockImageUpload = (lajiFormLocator) => __awaiter(this, void 0, void 0, function* () {
            const filePath = path.resolve(__dirname, "./pixel.png");
            const imageResponse = [{ name: "data", filename: "pixel.png", id: "mock", expires: 1575979685 }];
            const { resolve, remove } = yield this.setMockResponse("/images", false);
            const mdResponse = exports.mockImageMetadata;
            const { resolve: mdResolve, remove: mdRemove } = yield this.setMockResponse("/images/mock", false);
            yield this.getImageArrayField(lajiFormLocator).$dropzone.$("input").sendKeys(filePath);
            return {
                resolve: () => __awaiter(this, void 0, void 0, function* () {
                    yield resolve(imageResponse);
                    yield protractor_1.browser.sleep(300);
                    yield mdResolve(mdResponse);
                }),
                remove: () => __awaiter(this, void 0, void 0, function* () {
                    yield remove();
                    yield mdRemove();
                })
            };
        });
        this._getImageArrayField = (form) => (lajiFormLocator) => new class ImageArrayFieldPO {
            constructor() {
                this.$container = form.$locate(lajiFormLocator).$(".laji-form-medias");
                this.$$imgs = form.$locate(lajiFormLocator).$$(".media-container");
                this.$$imgInteractives = this.$$imgs.$$(".media-container a");
                this.$$imgRemoves = this.$$imgs.$$(".button-corner");
                this.$imgRemoveConfirmButton = (id) => form.$locateAddition(id, "delete-confirm-yes");
                this.$dropzone = form.$locate(lajiFormLocator).$(".laji-form-drop-zone");
                this.$modal = protractor_1.$(".laji-form.media-modal");
                this.$modalClose = this.$modal.$(".close");
            }
        };
        this.getImageArrayField = this._getImageArrayField(this);
        this._getTaxonAutosuggestWidget = (form) => (lajiFormLocator) => new class TaxonAutosuggestWidgetPO {
            constructor() {
                this.$input = form.$locate(lajiFormLocator).$("input");
                this.$suggestionsContainer = form.$locate(lajiFormLocator).$(".rw-list");
                this.$$suggestions = form.$locate(lajiFormLocator).$$(".rw-list-option");
                this.waitForSuggestionsToLoad = () => protractor_1.browser.wait(exports.EC.visibilityOf(this.$suggestionsContainer), 5000, "Suggestion list timeout");
                this.waitForGlyph = () => protractor_1.browser.wait(exports.EC.visibilityOf(form.$locate(lajiFormLocator).$(".glyphicon.form-control-feedback")), 5000, "Glyph didn't load");
                this.isSuggested = () => exports.isDisplayed(form.$locate(lajiFormLocator).$(".glyphicon-ok"));
                this.isNonsuggested = () => exports.isDisplayed(form.$locate(lajiFormLocator).$(".glyphicon-warning-sign"));
                this.$powerUserButton = protractor_1.$(".power-user-addon");
                this.powerUserButtonIsActive = () => __awaiter(this, void 0, void 0, function* () { return (yield this.$powerUserButton.getAttribute("class")).includes("active"); });
                this.waitForPopoverToHide = () => protractor_1.browser.wait(exports.EC.invisibilityOf(form.$locate(lajiFormLocator).$(".popover-content")), 5000, "Popover didn't hide");
            }
        };
        this.getTaxonAutosuggestWidget = this._getTaxonAutosuggestWidget(this);
        this.getScopeField = (lajiFormLocator) => ({
            $button: this.$locateButton(lajiFormLocator, "additionals"),
            $$listItems: this.$locate(lajiFormLocator).$$(".dropdown.open li a")
        });
        this.getUnitListShorthandArrayField = (lajiFormLocator) => ({
            $button: this.$locateButton(lajiFormLocator, "addUnitList"),
            modal: {
                $input: protractor_1.$(".unit-list-shorthand-modal input"),
                $addButton: protractor_1.$(".unit-list-shorthand-modal button")
            }
        });
        this.props = params;
    }
    initialize(beforeInit, contextId) {
        return __awaiter(this, void 0, void 0, function* () {
            const query = (params) => Object.keys(params).reduce((q, key) => `${q}&${encodeURIComponent(key)}=${encodeURIComponent(params[key])}`, "");
            if (this.props.id) {
                const _a = this.props, { id } = _a, _props = __rest(_a, ["id"]);
                yield exports.navigateToForm(id, query(_props));
            }
            else {
                yield exports.emptyForm();
            }
            beforeInit && (yield beforeInit(this));
            yield this.setState(this.props);
            this.contextId = contextId !== null && contextId !== void 0 ? contextId : yield this.e("lajiForm._id");
        });
    }
    e(path) {
        return protractor_1.browser.executeScript(`return window.lajiForm.${path}`);
    }
    setState(state) {
        const onSubmit = "function(data) {window.submittedData = data.formData;}";
        const onChange = "function(formData) {window.changedData = formData;}";
        return this.e(`setState({onSubmit: ${onSubmit}, onChange: ${onChange}, ...${JSON.stringify(state)}})`);
    }
    getState() {
        return __awaiter(this, void 0, void 0, function* () {
            return protractor_1.browser.executeScript("const {formData} = window.lajiForm.lajiForm.state; return {formData};");
        });
    }
    submit() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.e("submit()");
            yield waitUntilBlockingLoaderHides();
        });
    }
    startSubmit() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.e("submit()");
        });
    }
    submitOnlySchemaValidations() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.e("submitOnlySchemaValidations()");
        });
    }
    waitUntilBlockingLoaderHides(timeout) {
        return waitUntilBlockingLoaderHides(timeout);
    }
    getSubmittedData() {
        return protractor_1.browser.executeScript("return window.submittedData");
    }
    getChangedData() {
        return protractor_1.browser.executeScript("return window.changedData");
    }
    getPropsData() {
        return this.e("lajiForm.props.formData");
    }
    $locate(path) {
        return protractor_1.$(exports.getLocatorForContextId(this.contextId)(path));
    }
    $locateButton(path, selector) {
        return protractor_1.$(`#root${typeof path === "string" && path.length > 0 ? `_${path.replace(/\./g, "_")}` : ""}-${selector}`);
    }
    $locateAddition(path, selector) {
        return this.$locateButton(path, selector);
    }
    setMockResponse(path, query) {
        return __awaiter(this, void 0, void 0, function* () {
            yield protractor_1.browser.executeScript(`return window.setMockResponse(${JSON.stringify(path)}, ${JSON.stringify(query)})`);
            const mock = (method, response, raw) => protractor_1.browser.executeScript(`return ${this.getMockStr(path, query)}.${method}(${JSON.stringify(response)}, ${JSON.stringify(raw)})`);
            return {
                resolve: (response, raw) => mock("resolve", response, raw),
                reject: (response, raw) => mock("reject", response, raw),
                remove: () => mock("remove")
            };
        });
    }
    createMockResponseQueue(path, query) {
        return __awaiter(this, void 0, void 0, function* () {
            yield protractor_1.browser.executeScript(`return window.createMockResponseQueue(${JSON.stringify(path)}, ${JSON.stringify(query)})`);
            const queueStr = `window.mockQueues[window.getMockQueryKey(${JSON.stringify(path)}, ${JSON.stringify(query)})]`;
            const mock = (method, response, raw, pointer) => {
                return protractor_1.browser.executeScript(`return ${this.getMockStr(path, query)}[${pointer}].${method}(${JSON.stringify(response)}, ${JSON.stringify(raw)})`);
            };
            let pointer = 0;
            return {
                create: () => __awaiter(this, void 0, void 0, function* () {
                    yield protractor_1.browser.executeScript(`return ${queueStr}.create()`);
                    const _pointer = pointer;
                    pointer = pointer + 1;
                    return {
                        resolve: (response, raw) => mock("resolve", response, raw, _pointer),
                        reject: (response, raw) => mock("reject", response, raw, _pointer),
                    };
                }),
                remove: () => protractor_1.browser.executeScript(`return ${queueStr}.remove()`)
            };
        });
    }
    getBooleanWidget(str) {
        const $container = this.$locate(str).$(".btn-toolbar");
        return {
            $container,
            $true: $container.$$(".btn").get(0),
            $false: $container.$$(".btn").get(1),
            $undefined: this.$locate(str).$$(".btn").get(2),
            $active: $container.$(".btn.active"),
            $nonactive: $container.$$(".btn").filter(($btn) => __awaiter(this, void 0, void 0, function* () { return !(yield $btn.getAttribute("class")).includes("active"); })).first()
        };
    }
    $getInputWidget(str) {
        return this.$locate(str).$("input");
    }
    $getTextareaWidget(str) {
        return this.$locate(str).$("textarea");
    }
    $getEnumWidget(str) {
        const $container = this.$locate(str).$(".rw-combobox");
        return getEnumWidgetForContainer($container);
    }
    getDateWidget(str) {
        const $widget = this.$locate(str).$(".date-widget");
        return {
            $container: $widget,
            $input: $widget.$("input"),
            buttons: {
                $today: $widget.$(".today"),
                $yesterday: $widget.$(".yesterday"),
                $same: $widget.$(".same"),
                $date: $widget.$(".rw-i-calendar"),
                $time: $widget.$(".rw-i-clock-o")
            },
            calendar: {
                $today: $widget.$(".rw-calendar-footer button"),
                waitAnimation: () => protractor_1.browser.wait(exports.EC.visibilityOf($widget.$(".rw-calendar-footer button")), 1000, "Calendar didn't show")
            },
            clock: {
                "$01:00": $widget.$$(".rw-list li").get(2),
                waitAnimation: () => protractor_1.browser.wait(exports.EC.visibilityOf($widget.$(".rw-list")), 1000, "Clock didn't show")
            }
        };
    }
    $$getFieldErrors(str) {
        return this.$locate(str).$$(".laji-form-error-container li");
    }
}
exports.Form = Form;
const isDisplayed = ($elem) => __awaiter(void 0, void 0, void 0, function* () { return (yield $elem.isPresent()) && (yield $elem.isDisplayed()); });
exports.isDisplayed = isDisplayed;
const $mapPopupContainer = protractor_1.$(".named-place-popup");
const $namedPlaceChooserModal = protractor_1.$(".named-place-chooser-modal");
class NamedPlaceChooserPO {
    constructor() {
        this.select = getEnumWidgetForContainer(protractor_1.$("#named-place-chooser-select"));
        this.mapPopup = {
            $container: $mapPopupContainer,
            $useBtn: $mapPopupContainer.$(".btn-default")
        };
        this.$alert = $namedPlaceChooserModal.$(".alert");
        this.$close = $namedPlaceChooserModal.$(".close");
    }
}
exports.NamedPlaceChooserPO = NamedPlaceChooserPO;
function createForm(props, beforeInit) {
    return __awaiter(this, void 0, void 0, function* () {
        const form = new Form(props);
        yield form.initialize(beforeInit);
        return form;
    });
}
exports.createForm = createForm;
function waitUntilBlockingLoaderHides(timeout) {
    return protractor_1.browser.wait(protractor_1.protractor.ExpectedConditions.invisibilityOf(protractor_1.$(".laji-form.blocking-loader")), timeout || 20000, "Blocking loader timeout");
}
exports.waitUntilBlockingLoaderHides = waitUntilBlockingLoaderHides;
function putForeignMarkerToMap() {
    return __awaiter(this, void 0, void 0, function* () {
        const $gatheringsMap = exports.lajiFormLocate("gatherings").$(".laji-map");
        const $markerButton = protractor_1.$(".leaflet-draw-draw-marker");
        yield $markerButton.click();
        yield protractor_1.browser.actions().mouseMove($gatheringsMap.getWebElement(), { x: -100, y: -100 }).perform();
        yield protractor_1.browser.actions().click().perform();
    });
}
exports.putForeignMarkerToMap = putForeignMarkerToMap;
function removeUnit(gatheringIdx, unitIdx) {
    return __awaiter(this, void 0, void 0, function* () {
        yield protractor_1.$(`#root_gatherings_${gatheringIdx}_units_${unitIdx}-delete`).click();
        return protractor_1.$(`#root_gatherings_${gatheringIdx}_units_${unitIdx}-delete-confirm-yes`).click();
    });
}
exports.removeUnit = removeUnit;
const updateValue = ($input, value, blur = true) => __awaiter(void 0, void 0, void 0, function* () {
    const current = (yield $input.getAttribute("value")) || "";
    yield $input.click();
    yield $input.sendKeys(...Array(current.length).fill(protractor_1.protractor.Key.BACK_SPACE), value);
    if (blur) {
        return $input.sendKeys(protractor_1.protractor.Key.TAB);
    }
});
exports.updateValue = updateValue;
exports.mockImageMetadata = {
    "id": "mock",
    "capturerVerbatim": [
        "mock"
    ],
    "intellectualOwner": "mock",
    "intellectualRights": "MZ.intellectualRightsCC-BY-SA-4.0",
    "fullURL": "https://imagetest.laji.fi/MM.97056/pixel_full.jpg",
    "largeURL": "https://imagetest.laji.fi/MM.97056/pixel_large.jpg",
    "squareThumbnailURL": "https://imagetest.laji.fi/MM.97056/pixel_square.jpg",
    "thumbnailURL": "https://imagetest.laji.fi/MM.97056/pixel_thumb.jpg",
    "originalURL": "https://imagetest.laji.fi/MM.97056/pixel.png",
    "uploadedBy": "MA.308",
    "@context": "http://schema.laji.fi/context/image-en.jsonld"
};
const filterUUIDs = (any) => {
    if (typeof any === "object" && !Array.isArray(any) && any !== null) {
        return Object.keys(any).filter(key => key !== "_lajiFormId").reduce((_any, key) => (Object.assign(Object.assign({}, _any), { [key]: exports.filterUUIDs(any[key]) })), {});
    }
    else if (Array.isArray(any)) {
        return any.map(exports.filterUUIDs);
    }
    return any;
};
exports.filterUUIDs = filterUUIDs;
const maybeJSONPointerToLocator = (pointer) => pointer[0] === "/" ? pointer.slice(1).replace(/\//g, "_") : pointer;
exports.maybeJSONPointerToLocator = maybeJSONPointerToLocator;
