"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_utils_1 = require("./test-utils");
const protractor_1 = require("protractor");
describe("UnitListShorthandArrayField", () => {
    const schema = {
        type: "array",
        items: {
            type: "object",
            properties: {
                identifications: {
                    type: "array",
                    items: {
                        type: "object",
                        properties: {
                            taxon: { type: "string" }
                        }
                    }
                },
                unitFact: {
                    type: "object",
                    properties: {
                        autocompleteSelectedTaxonID: { type: "string" }
                    }
                },
                informalTaxonGroups: {
                    type: "array",
                    items: { type: "string" }
                }
            }
        }
    };
    const uiSchema = {
        "ui:field": "UnitListShorthandArrayField",
    };
    const formData = [];
    let form;
    let component;
    beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
        form = yield test_utils_1.createForm({ schema, uiSchema, formData });
        component = form.getUnitListShorthandArrayField("");
    }));
    it("button renders", () => __awaiter(void 0, void 0, void 0, function* () {
        expect(yield test_utils_1.isDisplayed(component.$button)).toBe(true);
    }));
    it("button click shows modal", () => __awaiter(void 0, void 0, void 0, function* () {
        yield component.$button.click();
        yield protractor_1.browser.wait(test_utils_1.EC.visibilityOf(component.modal.$addButton), 100, "Modal didn't show up");
    }));
    it("typing species in and submitting gets the formData", () => __awaiter(void 0, void 0, void 0, function* () {
        yield test_utils_1.updateValue(component.modal.$input, "susi, kettu");
        yield component.modal.$addButton.click();
        yield form.waitUntilBlockingLoaderHides(5000);
        const formData = yield form.getChangedData();
        expect(formData[0]["informalTaxonGroups"]).toContain("MVL.2");
        expect(formData[0]["identifications"]).toEqual([{ "taxon": "susi" }]);
        expect(formData[0]["unitFact"]).toEqual({ "autocompleteSelectedTaxonID": "MX.46549" });
        expect(formData[1]["informalTaxonGroups"]).toContain("MVL.2");
        expect(formData[1]["identifications"]).toEqual([{ "taxon": "kettu" }]);
        expect(formData[1]["unitFact"]).toEqual({ "autocompleteSelectedTaxonID": "MX.46587" });
    }));
});
