"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_utils_1 = require("./test-utils");
const protractor_1 = require("protractor");
describe("water bird pair count form (MHL.65)", () => {
    let form;
    beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
        form = yield test_utils_1.createForm({ id: "MHL.65", localFormData: true });
    }));
    it("sets correct unitType to pair observations when using add button", () => __awaiter(void 0, void 0, void 0, function* () {
        yield form.$locateButton("gatherings_0_units", "add").click();
        const formData = yield form.getChangedData();
        expect(formData.gatherings[0].units[0].unitType[0]).toBe("pairObservation");
    }));
    it("sets correct unitType to pair observations when using insert shorthand", () => __awaiter(void 0, void 0, void 0, function* () {
        yield form.$locateButton("gatherings_0_units", "add").click();
        yield protractor_1.browser.driver.switchTo().activeElement().sendKeys(protractor_1.protractor.Key.chord(protractor_1.protractor.Key.ALT, "i"));
        const formData = yield form.getChangedData();
        expect(formData.gatherings[0].units[1].unitType[0]).toBe("pairObservation");
    }));
});
